Summary:	Bruce's C compiler
Summary(pl.UTF-8):	Kompilator C Bruce'a
Name:		bcc
Version:	0.16.19
Release:	1
License:	GPL
Group:		Development/Languages
Source0:	http://www.debath.co.uk/dev86/Dev86src-%{version}.tar.gz
# Source0-md5:	442e98e1afa23fe00d40c5a996385942
Patch0:		Dev86src-noroot.patch
Patch1:		Dev86src-opt.patch
Patch2:		dev86-0.16.17-fortify.patch
Patch3:		dev86-pic.patch
Patch4:		dev86-64bit.patch
Patch5:		dev86-noelks.patch
Patch6:		dev86-nostrip.patch
Patch7:		dev86-print-overflow.patch
Patch8:		dev86-make.patch
Patch9:		dev86-copt.patch
Patch10:	dev86-format.patch
URL:		http://www.debath.co.uk/
Requires:	bin86 >= %{version}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# don't try to strip Linux-8086 objects
%define		_noautostrip	.*%{_libdir}/bcc/.*\\.[ao]


%description
Bcc is a simple C compiler that produces 8086 assembler, in addition
compiler compile time options allow 80386 or 6809 versions. The
compiler understands traditional K&R C with just the restriction that
bit fields are mapped to one of the other integer types.

%description -l pl.UTF-8
Bcc jest prostym kompilatorem C tworzącym pliki asemblerowe 8086,
a dodatkowo pozwala na wybranie wersji 80386 lub 6809. Kompilator
rozumie tradycyjne C K&R z takim ograniczeniem, że pola bitowe
są odwzorowywane do jednego z innych typów całkowitych.

%prep
%setup -q -n dev86-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p0
%if "%{_lib}" == "lib64"
%patch4 -p1
%endif
%ifnarch %{ix86}
%patch5 -p1
%endif
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1

mv -f bootblocks/README README.bootblocks
mv -f copt/README README.copt
mv -f dis88/README README.dis88
mv -f elksemu/README README.elksemu
mv -f unproto/README README.unproto

%build
CC="%{__cc}" \
%{__make} -j1 all other \
	OPT="%{rpmcppflags} %{rpmcflags}" <<!FooBar!
5
quit
!FooBar!

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -j1 install-all \
	DIST=$RPM_BUILD_ROOT \
	LIBDIR=%{_libdir}/bcc \
	INCLDIR=%{_libdir}/bcc \
	LOCALPREFIX=%{_prefix} \
	MANDIR=%{_mandir}

cp -R libc/kinclude $RPM_BUILD_ROOT%{_libdir}/bcc

ln -sf objdump86 $RPM_BUILD_ROOT%{_bindir}/nm86
ln -sf objdump86 $RPM_BUILD_ROOT%{_bindir}/size86

# these are separated in bin86 package
%{__rm} $RPM_BUILD_ROOT%{_bindir}/{as86,ld86}
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/{as,ld}86.1*

%ifnarch %{ix86}
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/elks*.1
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc Changes Contributors README*
%attr(755,root,root) %{_bindir}/ar86
%attr(755,root,root) %{_bindir}/bcc
%attr(755,root,root) %{_bindir}/dis86
%ifarch %{ix86}
%attr(755,root,root) %{_bindir}/elksemu
%endif
%attr(755,root,root) %{_bindir}/makeboot
%attr(755,root,root) %{_bindir}/nm86
%attr(755,root,root) %{_bindir}/objdump86
%attr(755,root,root) %{_bindir}/size86
%dir %{_libdir}/bcc
%attr(755,root,root) %{_libdir}/bcc/as86_encap
%attr(755,root,root) %{_libdir}/bcc/bcc-cc1
%attr(755,root,root) %{_libdir}/bcc/bcc-cpp
%attr(755,root,root) %{_libdir}/bcc/copt
%attr(755,root,root) %{_libdir}/bcc/unproto
%{_libdir}/bcc/i386
%{_libdir}/bcc/include
%{_libdir}/bcc/kinclude
%{_libdir}/bcc/crt*.o
%{_libdir}/bcc/lib*.a
%{_libdir}/bcc/rules.*
%{_mandir}/man1/bcc.1*
%{_mandir}/man1/dis86.1*
%ifarch %{ix86}
%{_mandir}/man1/elks.1*
%{_mandir}/man1/elksemu.1*
%endif
%changelog
* Fri Oct 26 2012 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/bcc.git;a=log;h=master

* Fri Oct 26 2012 Jakub Bogusz <qboosh@pld-linux.org> 53a8b53
- added format patch to fix build with -Werror=format-security

* Fri Oct 26 2012 Jakub Bogusz <qboosh@pld-linux.org> 3a66258
- updated to 0.16.19
- updated opt,fortify patches
- removed obsolete long patch

* Thu Sep 20 2012 Marcin Krol <hawk@tld-linux.org> 66d65e6
- fix for "ncc: illegal label" build error, taken from Debian

* Thu Apr 05 2012 Jakub Bogusz <qboosh@pld-linux.org> 7992e3f
- new URLs, updated to 0.16.18
- updated opt patch, removed obsolete make382 patch
- added make patch to adjust dis86 Makefile (add MANDIR support, kill stripping)
- use _noautostrip for individual files instead of disabling autostripping globally

* Wed Feb 29 2012 Jan Rękorajski <baggins@pld-linux.org> f24e9fd
- rel 6
- build on x8664
- don't build elks on x664 (does not build)
- fix various bugs (from FC)

* Wed Feb 29 2012 Jan Rękorajski <baggins@pld-linux.org> 1331657
- new source url

* Mon Mar 28 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 45c7a6c
- rel 5; fortify and make fixes from gentoo

* Mon Mar 28 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 7b0d852
- release 4

* Sat Jul 31 2010 Jan Rękorajski <baggins@pld-linux.org> 4cc830e
- rel 3
- no parallel build

* Thu Jan 24 2008 Elan Ruusamäe <glen@pld-linux.org> 7d6c1ae
- todo for global strip disable

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> 57604c0
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 8c14594
- converted to UTF-8

* Fri Jan 19 2007 Elan Ruusamäe <glen@pld-linux.org> 79386f7
- new URL

* Fri Jan 19 2007 Elan Ruusamäe <glen@pld-linux.org> 02103d9
- be re-entrant

* Fri Jan 19 2007 Arkadiusz Miśkiewicz <arekm@maven.pl> a7de289
- rel 2

* Fri Jun 10 2005 Jakub Bogusz <qboosh@pld-linux.org> 549a0d6
- updated to 0.16.17, removed obsolete segv patch

* Fri Jun 10 2005 Jakub Bogusz <qboosh@pld-linux.org> 45317fe
- obsolete

* Fri Sep 03 2004 Jakub Bogusz <qboosh@pld-linux.org> f11e9fe
- updated to 0.16.16, added segv patch

* Fri Sep 03 2004 Jakub Bogusz <qboosh@pld-linux.org> fc08163
- kill deadly typo

* Tue Jan 27 2004 Jakub Bogusz <qboosh@pld-linux.org> 726244e
- updated to 0.16.15
- updated noroot,opt patches, removed obsolete errno,nobcc patches

